# Table of Contents

* [1 传输媒体](#1-传输媒体)
* [2 物理层主要任务](#2-物理层主要任务)
* [3 传输方式](#3-传输方式)
  * [3.1 串并行方式](#31-串并行方式)
  * [3.2 同异步传输](#32-同异步传输)
  * [3.3 单工/半双工/全双工](#33-单工半双工全双工)
* [4 编码和调制](#4-编码和调制)
  * [4.1 定义](#41-定义)
  * [4.2 码元](#42-码元)
  * [4.3 常用编码和调制方法](#43-常用编码和调制方法)
* [5 信道的极限容量](#5-信道的极限容量)
  * [5.1 奈氏准则](#51-奈氏准则)
  * [5.2 香农公式](#52-香农公式)


# 1 传输媒体
物理层传输媒体可以分为两类：

- 导引型传输媒体：双绞线、同轴电缆、光纤
- 非导引型传输媒体：微波通信

# 2 物理层主要任务
物理层为了解决在各种传输媒体上传输0和1的问题，主要任务如下：

- 机械特性
- 电气特性
- 功能特性
- 过程特性

物理层考虑的是怎样才能在连接各种计算机的传输媒体上传输比特流，为数据链路层屏蔽各种传输媒体的差异，使数据链路层只需要考虑如何完成本层的协议和服务，而不必考虑网络具体的传输媒体是什么。

# 3 传输方式
## 3.1 串并行方式
- 串行传输：只需要一条传输线路，一次发送一个比特
- 并行传输：一次发送n个比特

计算机网络中采用的是串行传输，在计算机内部采用并行传输。

![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511142243187.png)


## 3.2 同异步传输
- 同步传输：数据块以稳定的比特流方式传输，数据块之间没有间隔，需要双方时钟同步，方法包括外同步（双方单独添加一条时钟信号线）和内同步（时钟同步信号编码到数据中一起传输，比如曼彻斯特编码）
- 异步传输：以字节为独立传输单位，字节之间的传输间隔不固定，接收端在每个字节的起始处对字节内的比特实现同步

![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511142219507.png)

## 3.3 单工/半双工/全双工

- 单工：也就是单向通信，通信双方只有一个传输方向，比如广播的接收
- 半双工：也就是双向交替通信，通信双方可以相互传输数据，但不能同时进行，比如对讲机
- 全双工：也就是双向同时通信，通信双方可以同时发送和接收信息，比如电话

# 4 编码和调制
## 4.1 定义
发送数据的时候，网卡将比特0和比特1变换成相应的电信号发送到网线，也就是信号是电磁的表现，由信源发出的原始电信号称为基带信号，基带信号可以分为两类：

- 数字基带信号
- 模拟基带信号

信号需要在信道中传输，信道可以分为：

- 数字信道
- 模拟信道

 在不改变信号性质的前提下，仅对数字基带信号的波形进行变换，称为编码，编码后的信号仍然是数字信号，可以在数字信道中传输，例如曼彻斯特编码。
 
把数字基带信号的频率范围，搬移到较高频段，并转换为模拟信号，称为调制，调制后产生的信号是模拟信号，可以在模拟信道中传输。

![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511143312503.png)

## 4.2 码元
码元就是不同离散数值的基本波形，简单来说就是构成信号的一段波形。

## 4.3 常用编码和调制方法
常用编码：

- 不归零编码：存在同步问题
- 归零编码：自同步，但是效率低
- 曼彻斯特编码
- 差分曼彻斯特编码

![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511144425196.png)

基本调制方法：

- 调幅
- 调频
- 调相
- 混合调制


![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511144351903.png)

# 5 信道的极限容量
## 5.1 奈氏准则
表述如下：
```bash
在假定的理想条件下，为了避免码间串扰，码元传输速率是有上限的。

理想低通信道的最高码元传输速率为 2W baud
理想带通信道的最高码元传输速率为 W Baud
```
`Baud`也叫波特，单位为`码元/秒`。码元传输速率又叫波特率，当1个码元只携带1比特的信息量时，波特率与比特率在数值上是相等的，当1个码元携带n比特信息量时，波特率转换为比特率时，数值需要乘n。

换句话说，如果需要提高比特率，那就需要使得每一个码元能携带更多个比特的信息，也就是需要采用多元制，比如`QAM16`。

## 5.2 香农公式
![在这里插入图片描述](https://img-blog.csdnimg.cn/20210511145316331.png)

- c是信道极限信息传输速率
- W是信道带宽
- S是信道内传输信号的平均功率
- N是信道内的高斯噪声功率
- S/N是信噪比

总的来看，在信道带宽一定的情况下，要提高信息的传输速率，必须采用多元制和努力提高信道中的信噪比。
