﻿
# 1 操作系统的目标

- 方便性
- 有效性
- 可扩充性
- 开放性

# 2 操作系统的作用
- 用户于计算机硬件系统之间的接口
- 计算机系统资源的管理者
- 实现了对计算机资源的抽象

# 3 OS发展过程

## 3.1 人工操作方式
早期的操作方式是程序员将实现已穿孔的纸带或卡片，装入纸带输入机，再启动它们将纸带或卡片上的程序和数据输入计算机，然后启动计算机运行。仅当程序运行完毕并取走计算结果后，才允许下一个用户上机。

缺点：

- 用户独占全机
- CPU等待人工操作
- 严重降低了计算机资源的利用率

## 3.2 脱机IO方式
事先将装有用户程序和数据的纸带装入纸带输入机，在一台外围机的控制下，把纸带或卡片上的数据或程序输入到磁带上，当CPU需要这些程序和数据的时候，再从磁带上高速调入内存。

输出时，CPU把数据直接从内存告诉地传输到磁带上，然后在另一台外围机的控制下，再将磁带上的结果通过相应的输出设备输出。

脱机中的“机”是指“主机”，也就是脱离主机，优点为：

- 减少CPU空闲时间
- 提高IO速度

## 3.3 单通道批处理系统
处理过程如下：

- Monitor将磁带上第一个作业装入内存，把控制权交给作业
- 作业完成后归还控制权给Monitor
- Monitor再将第二个作业转入内存，以此类推

系统对作业的处理是成批进行的，但是在内存中始终保持一道作业，故称为单通道批处理系统。

缺点就是系统中的资源得不到充分利用，比如下图中绿色表示CPU等待I/O的空闲时间。

![在这里插入图片描述](https://img-blog.csdnimg.cn/20200910124859645.png)

## 3.4 多通道批处理系统
处理步骤：

- 将用户所提交的作业先存放在外存上，并排成一个叫“后备队列”的队列
- 作业调度程序按一定算法选择作业调入内存
- 由于内存中存储若干作业，CPU等待作业A进行I/O时，处理作业B
- 交替利用前一个作业的I/O空闲时间处理下一个作业，直到内存中的作业完成

![在这里插入图片描述](https://img-blog.csdnimg.cn/20200910125648715.png)

优点：

- 资源利用率高
- 系统吞吐量大

缺点：

- 平均周转时间长
- 无交互能力

## 3.5 分时系统

### 3.5.1 定义
在一台主机上连接了多个配有显示器和键盘的终端所组成的系统，该系统允许多个用户同时通过自己的终端，以交互的方式使用计算机并共享主机中的资源。

### 3.5.2 如何做到及时接收
答案：配置了多路卡。

多路卡的作用是是实现分时多路复用。即主机以很快的速度周期性扫描各个终端，在每个终端的停留很短的时间，如30ms，用于接收从终端发来的数据。


### 3.5.3 如何做到及时处理
- 作业直接调入内存
- 采用轮转运行方式：引入了时间片的概念，一个时间片就是一段很短的时间，系统规定每个作业每次只能运行一个时间片，然后就暂停该作业的运行并立即调度下一个作业运行

### 3.5.4 特征
- 多路性
- 独立性
- 及时性
- 交互性


## 3.6 实时系统
### 3.6.1 定义
系统能够及时响应外部事件的请求，在规定的时间内完成对该事件的处理，并控制所有实时任务协调一致运行。


### 3.6.2 实时任务类型
按周期性分：

- 周期性实时任务：外部设备周期性发送激励信号给计算机，要求它按指定周期循环执行
- 非周期性实时任务：无明显周期性，但是必须联系着一个截止时间

按对截止时间的要求分类：

- 硬实时任务：系统必须满足实时任务对截止时间的要求
- 软实时任务：偶尔错过了任务截止时间对系统产生的影响不大

## 3.7 微机操作系统

## 3.7.1 单用户单任务系统
主要配置在8/16位微机上，比如：

- `CP/M`：`Digital Research`开发的带有软盘系统的8位微机操作系统
- `MS-DOS`：微软开发

### 3.7.2 单用户多任务系统
只允许一个用户上机，但允许用户把程序分为若干个任务的操作系统。比如：`Win95`、`WinXP`等。


### 3.7.3 多用户多任务操作系统
允许多个用户通过各自的终端，使用同一台机器，共享主机系统中的各种资源的系统。比如：

- `Unix`
- `Linux`
- `Solaris OS`

# 4 操作系统的基本特征
四个：

- 并发
- 共享
- 虚拟
- 异步

## 4.1 并发
### 4.1.1 并发与并行
首先明确一下并行与并发。并行是指两个或多个事件在同一个时刻发生，并发是指两个或多个事件在同一个时间间隔发生。下面是一个来自知乎的例子：

```bash
你吃饭吃到一半，电话来了，你先停下吃饭，再去接电话，电话完了之后回来继续吃饭，说明你支持并发。
你吃饭吃到一般，电话来了，你一边吃饭一边接电话，说明你支持并行。
```

因此：

- 两者共同点为**都能处理多个任务**
- 两者不同点为**是否同时处理多个任务**


### 4.1.2 进程
进程：能独立运行并作为资源分配的基本单位，有一组机器指令、数据和堆栈组成，是一个能独立活动的实体。


## 4.2 共享
共享是指资源复用，指系统中的资源可供内存中多个并发执行的进程共同使用。一般方式如下：

- 互斥共享方式：在一段时间内只允许一个进程访问资源
- 同时访问方式：宏观意义上是“同时”访问，微观意义上是交替进行的，比如磁盘设备


## 4.3 虚拟
通过某种技术将一个物理实体变为若干个逻辑上对应物的功能称为虚拟。常用的技术如下：

- 时分复用技术
- 空分复用技术

### 4.3.1 时分复用技术
利用某设备为一个用户服务的空闲时间去为其他用户服务，比如：

- 虚拟机处理技术
- 虚拟设备技术

### 4.3.2 空分复用技术
利用存储器的空闲空间区域存放和运行其他的多道程序，提高内存利用率。


## 4.4 异步
对内存中的每个进程，在何时能获得处理机运行，何时又因提出某种资源请求而暂停等是不可预知的，这就是进程的异步性。

# 5 操作系统的主要功能
四个基本功能：

- 处理机管理
- 存储器管理
- 设备管理
- 文件管理

## 5.1 处理机处理
主要功能：

- 进程控制：创建/撤销进程
- 进程同步：常用进程协调方式包括进程互斥方式以及进程同步方式
- 进程通信：进程间的信息交换
- 调度：包括作业调度以及进程调度

## 5.2 存储器管理
主要包括：

- 内存分配：动/静态分配内存，提高存储器利用率
- 内存保护：确保每道程序在各自内存空间运行，不允许越界访问
- 地址映射：逻辑地址与物理地址之间的映射
- 内存扩充：包含请求调入功能以及置换功能

## 5.3 设备管理功能
主要包括：

- 缓冲管理：I/O与CPU之间引入缓冲机制等
- 设备分配：按照资源对设备分配
- 设备处理：基本任务是实现CPU和设备管理器之间的通信

## 5.4 文件管理功能
主要包括：

- 文件存储空间的管理：设置相应数据结构记录文件存储空间的使用情况等
- 目录管理：为每个文件建立一个目录项等
- 文件读写管理和保护：处理读写请求，同时保护文件防止被非法窃取和破坏



# 6 结构
操作系统的结构主要发展过程如下：

- 无结构系统
- 模块化结构系统
- 分层结构系统

## 6.1 无结构系统
早期开发的操作系统大多为无结构系统。

## 6.2 模块化结构系统
比如一个操作系统可以分成四个大模块：处理机管理、存储器管理、设备管理、文件管理，每一个又可以分成子模块：

![在这里插入图片描述](https://img-blog.csdnimg.cn/20200910133727230.png)

优点：

- 提高正确性、可理解性、可适应性以及可维护性
- 加速开发过程

缺点：

- 接口不一定满足实际需求
- 设计者需要整体考虑

## 6.3 分层结构系统
一个系统分为n层，每一层只能依赖上一层提供的服务，通常使用自底向上法铺设中间层。主要优点有：

- 保证系统的正确性
- 易扩充和维护


# 7 微内核系统
## 7.1 特征
微内核结构的基本特征为：

- 足够小的内核：内核并非一个完整OS，只包含最基本的部分
- 基于客户/服务器模式：内核充当服务器，客户进程、文件管理器等作为客户端
- 机制与策略分离：机制是指实现某一功能的具体执行机构，策略是在机制的基础上借助于某些参数和算法实现功能的优化，通常将机制放在内核较低层，策略放在内核叫高层
- 采用面向对象技术

## 7.2 基本功能
- 进程/线程管理
- 低级存储器管理
- 中断和陷入处理

## 7.3 优点
- 提高系统可扩展性
- 增强系统可靠性
- 可移植性强
- 分布式支持
- 融入面向对象技术


## 7.4 缺点
缺点就是需要在用户态和系统态之间反复切换。



